#include <FK/FK.h>

// [VĐpNXg錾
#include "FKUT/MotionCharactor.h"
// t[[gNXg錾
#include "FKUT/FrameController.h"

// [Trans]؂ւGtFNgTvNXg錾
#include "TransitionEffect.h"


// enum^gĂ݂悤
enum Girl_MotionStatus {
	GIRL_STOP = -1,
	GIRL_WALK,
	GIRL_PUNCH,
	GIRL_KICK
};


int main(int argc, char *argv[])
{
	Fl_Window		main_win(512, 512, "FKP Motion Play Sample");
	fk_Light		light;
	fk_Model		camera, lightModel;
	fk_Scene		scene;
	fk_Window		fk_win(0, 0, 512, 512);

	fkut_FrameController	frame;

	// [VĐpNX̕ϐp
	CMotionCharactor	chara;

	// [Vp̕ϐ(gpȂ̂ŕK{ł͂Ȃ)
	Girl_MotionStatus motionID = GIRL_STOP;

	// [Trans]FKUTtH_SpriteModelĝŕKp邱
	CTransitionEffect	trans;


	// EBhE̍쐬
	main_win.end();
	// Fpbg̏
	fk_InitMaterial();

	// J̈ʒuƕݒ
	camera.glMoveTo(0.0, 30.0, 100.0);
	camera.glFocus(0.0, 30.0, 0.0);

	// Ɩ̐ݒ
	lightModel.setShape(&light);
	lightModel.setMaterial(White);
	lightModel.glFocus(-1.0, -1.0, -1.0);

	// fBXvCXgɃfƎ_ݒ
	scene.entryModel(&lightModel);
	scene.entryCamera(&camera);
	scene.setBGColor(1.0, 1.0, 1.0);

	// [Trans]ʃtF[h┼eNX`gꍇ͕Kfk_Sceneɑ΂ĂĂԂ
	// SimpleWindowł͎IɌĂłA͓OɂȂĂ̂
	// KĂł炢̋Cō\Ȃ
	scene.setBlendStatus(true);

	// EBhEɃfBXvCXgݒ
	fk_win.setScene(&scene);

	// EBhEۂɕ`
	main_win.show();

	// ^ZR̃f[^ǂݍ
	if(!chara.loadObjectData("girl/girl.mqo")) fl_alert("Object Read Error.");
	// ZbgAbvf[^ǂݍ
	if(!chara.loadJointData("girl/girl_setup.fkc")) fl_alert("Joint Read Error.");
	// [Vf[^ǂݍ݂ǂݍ
	if(!chara.loadMotionData("girl/walk.fkm")) fl_alert("Motion Read Error.");
	if(!chara.loadMotionData("girl/punch2.fkm")) fl_alert("Motion Read Error.");
	if(!chara.loadMotionData("girl/kick2.fkm")) fl_alert("Motion Read Error.");

	// 傢ƉĂ炤
	chara.getBaseModel()->glFocus(-1.0, 0.0, 0.0);

	// V[ւ̃Gg[(fk_Scene ̕ϐ & ēn)
	chara.entryScene(&scene);

	while(true){
		// t[
		frame.TimeRegular();

		// [v̂܂菈
		if(main_win.visible() == 0){
			if(Fl::wait() == 0){
				break;
			}else{
				continue;
			}
		}
		if(frame.GetDrawFlag()) fk_win.drawWindow();
		if(Fl::check() == 0) break;
		if(fk_win.winOpenStatus() == false) continue;

		// [Trans]t[Ă
		trans.update(&scene);

		// [Trand]fadeTo(),fadeFrom()͊Jnuuԁv1xĂ
		if(fk_win.getSpecialKeyStatus(FK_PAGE_UP, false)) {
			trans.fadeTo(0.0, 0.0, 0.0, 1000);
		}
		if(fk_win.getSpecialKeyStatus(FK_PAGE_DOWN, false)) {
			trans.fadeFrom(0.0, 0.0, 0.0, 1000);
		}


		// L[ɂčĐĂ郂[V̏Ԃω
		if(fk_win.getKeyStatus('1')) {
			motionID = GIRL_WALK;	// 0ŏɓǂݍ񂾃[V()\
		} else if(fk_win.getKeyStatus('2')) {
			motionID = GIRL_PUNCH;	// 12Ԗڂ(ry
		} else if(fk_win.getKeyStatus('3')) {
			motionID = GIRL_KICK;	// 23Ԗڂ(ry
		} else if(fk_win.getKeyStatus('0')) {
			motionID = GIRL_STOP;	// -1͐Î~Ԃ\
		}

		// [V ID ɂāAĐ郂[V̎ނ𕪊򂷂

		// [v1񂲂Ƃ playMotion(Đԍ) ĂԂ1t[[Vi
		// Đԍ loadMotionData() œǂݍ񂾏(0X^[g)

		switch(motionID) {
			case GIRL_WALK:	// <-R(:)łBZ~R(;)ȂI
				// ƌĂёƌJԂĐ
				chara.playMotion(motionID);
				break;	// breaktȂƁȀ̏܂ŗĂႤ
			case GIRL_PUNCH:
			case GIRL_KICK:	// breaktɎcase΁Acaseŋʂ̏
				// 1񂫂̍ĐŎ~߂ꍇ́AIođΏ
				if(chara.isMotionFinished(motionID) == true) {
					// [VIĂꍇ͉Ȃ悤ɂA
					// ̃[V֌q肷΂悢

					// ̗Ⴞƍŏ̃t[߂A
					// ID-1ɂčĐ͎~߂悤ɂĂ
					// x2΍Đ
					chara.setNowFrame(motionID, 0);
					motionID = GIRL_STOP;
				} else {
					chara.playMotion(motionID);
				}
				break;
			default:	// ܂łŏcaseɓĂ͂܂Ȃꍇ̏
				break;
		}

		// [VĐ̃LN^[𓮂ɂ getBaseModel()-> ɑ΂
		// fk_Model ̖߂g
		if(fk_win.getSpecialKeyStatus(FK_UP, false)) {
			chara.getBaseModel()->glTranslate(0.0, 0.5, 0.0);
		}
		if(fk_win.getSpecialKeyStatus(FK_DOWN, false)) {
			chara.getBaseModel()->glTranslate(0.0, -0.5, 0.0);
		}
	}

	return 0;
}
